REBOL [
	title: "FFB Import"
	author: "Grard Joyez"
    purpose: {
    	To import frequencies and percentages from Simultans Fdration Franaise de Bridge.
		presently works only for Rondes de la socit Gnrale
	}
]

system/schemes/http/user-agent: "Mozilla/4.0 (compatible; MSIE 5.5; Windows NT 5.0)"

DF-Directory: "/C/Bridge/Deep Finesse 26-Nov-99/deal archives/"
Pbn-directory: "/C/Bridge/Donnes Pbn/Rondes SG/"
Tabulations: [7 11 18 24]
Vuln: ""
Donneur: ""
Frquences: copy []
Nord: copy ""
Est: copy ""
Sud: copy ""
Ouest: copy ""
NumDonne: 0
Donne-DF: copy ""
Commentaire: copy ""

;paramtres de connexion
site: http://www.gestion.ffbridge.asso.fr/servlet/
headers: none
session-id: none
Servlet_Cible: "FFBSimAffichageResultatsSimultaneSitePublic.ServletChoixCriteres"
oh_Hid_num_changement: 3
os_DDn_Type_Simultane: "3;Rondes%20Societe%20generale;null"
od_Txt_dt_org: "22/10/2004"
os_DDn_Moment: "210;Aprs-Midi;ON;VAL;16;04/11/2004"
os_DDn_Affichage: "frequence"

;procdure mettant et collectant des requtes
lire-site: func [
	servlet [string!]
	data [string!]
	/local header url result
][
	header: either headers [
		if none? session-id[session-id: parse/all headers/Set-Cookie "=;"]
		compose/deep [post (data) [Cookie: (rejoin [session-id/1 "=" session-id/2])]]
	][
		compose/deep [post (data)]
	]
	url: rejoin [site servlet]
	if 1 > to-integer NumDonne [probe url]
	port: open/custom url header
	headers: port/locals/headers
	result: copy port
	close port
	result
]

; extrait une ligne de frquences
Extraire-ligne: does[
	parse table [thru {<TR } copy ligne to "</TR>" table: copy table]
	replace/all ligne {class="paire">} ""
	replace/all ligne {<TD align=right>} ""
	replace/all ligne "</td>" " "
	replace/all ligne {>} ""
	replace/all ligne newline ""
	append/only frquences ligne
]
Suit-Collect: func[
"extrait les cartes d'une couleur et d'une main et limine le texte correspondant et celui qui prcde"
	Couleur [string!]
	/local Hand Balise Suit
	][
	Hand: copy ""
	Balise: Couleur
		Texte: copy find texte Balise
		parse texte[thru "<ul>" copy suit to "</ul>"]
	for I 1 12 1[
		while [found? find suit "<li>"][
			Suit: copy skip find suit "<li>" 5
		parse suit [copy H to newline]
		replace/all H newline ""
		trim/all H
		replace H "R" "K"
		replace H "D" "Q"
		replace H "V" "J"
		replace H "10" "T"
		append hand H
		]
	]
	Hand
]
; extrait une main
Main-collect: does[
	rejoin[
		suit-collect {pique} "."
		suit-collect {coeur} "."
		suit-collect {"carreau} "."
		suit-collect {"trefle"}
	]
]
Choix-Fichier: does[
;Choisir le fichier destination
	File-to-save:  request-file/title/only/filter "Sauvegarder les Donnes" "Enregistrer" "*.pbn" 
	if not found? find file-to-save ".pbn"[append file-to-save ".pbn"]
	fichier-dfaut/text: file-to-save
]		
;procdure appele par la fentre de choix
connect: does[
	Donne: copy ""
;ouvrir la session
	data: rejoin [
		"oh_Hid_num_changement=" oh_Hid_num_changement
		"&" "os_DDn_Type_Simultane=" os_DDn_Type_Simultane
		"&" "od_Txt_dt_org=" Date/text
	]
	page: lire-site Servlet_Cible data
;extraire la variable lie au choix du moment
	p: copy/part page index? find page join ">" Moment/text
	m: copy  find/last p "<"
	os_DDn_Moment: second parse/all m {"}
	data: rejoin [
		"oh_Hid_num_changement=" oh_Hid_num_changement
		"&" "os_DDn_Moment=" os_DDn_Moment
		"&" "os_DDn_Affichage=" os_DDn_Affichage
	]
;terminer le paramtrage du serveur
	p: lire-site Servlet_Cible data
;	write %testffb.html lire-site Servlet_Cible data
;browse  %testffb.html
;demander le rsultat de la premire donne
	Servlet_Cible: "FFBSimAffichageResultatsSimultaneSitePublic.ServletAffichageFrequenceEtDonne"
   data: rejoin [
   	"oh_Hid_num_changement=" 10
   ]
	texte: lire-site Servlet_Cible data
; extraction du commentaire
	;parse find texte "</TABLE>"[thru "<b>" copy Commentaire to "</b>"]
	;replace/all Commentaire newline ""
; recherche du nombre de donnes  tlcharger
	p: copy/part texte index? find texte "</Select>"
	maxDonne: to-integer first parse (copy skip p index? find/last p  " ") "<"
	Extraire-Donnes
	data: copy "os_DDn_Donne="
	for I 2 maxDonne 1[
		texte: lire-site Servlet_Cible (join data I)
		Extraire-Donnes
	]
	either exists? to-file pbn-Directory[
		write to-file join pbn-directory file-to-save Donne
		][
		write to-file file-to-save Donne
	]
	if DF-Check/data[
		either exists? to-file DF-Directory[
			write to-file (join DF-Directory File-DF) Donne-DF
			][
			write to-file File-DF Donne-DF
		]
	]
	quit
]
Extraire-Donnes: does[
	parse texte[thru "Note EO</TH>" copy table to "</table"]
   texte: copy  find texte "Vuln&eacute;rabilit&eacute;"
	texte: copy find texte "<br>"
;extraire la vulnrabilit
	parse texte [thru  newline  copy Vuln  to newline]
;extraire les cartes par couleur et par main
	Nord: Main-collect
	Ouest: Main-collect
;extraire le numro de la donne
	parse texte [thru  "N&deg;" copy NumDonne  to </td>]
	trim NumDonne
	Est: Main-collect
	Sud: Main-collect
; extraire le donneur
	parse texte [thru  "Donneur" copy Donneur  to </td>]
	replace/all Donneur newline ""
	trim/all Donneur
;composer la chaine dcrivant la donne au format .pbn
  	strhands: switch Donneur[
  		"Nord" [rejoin ["N:" Nord " " Est " " Sud " " Ouest]]
  		"Est" [rejoin ["E:" Est " " Sud " " Ouest " " Nord ]]
  		"Sud" [rejoin ["S:" Sud " " Ouest " " Nord " " Est]]
  		"Ouest" [rejoin ["W:" Ouest " " Nord " " Est " " Sud ]]
  	]
print rejoin[ "Donne n" NumDonne tab strhands]
;extraire les frquences: rcuprer la table
  	clear Frquences
	while [10 < length? table][extraire-ligne]
  	vuln: switch trim Vuln[
  		"Personne" ["None"]
  		"Nord Sud" ["NS"]
  		"Est Ouest" ["EW"]
  		"Tous Vulnrables" ["All"]
  		"Tous" ["All"]
  	]
  	append Donne rejoin [
  		{[Event "Rondes Socit Gnrale"]} newline
     	{[Board "} NumDonne {"]} newline
     	{[Vulnerable "} Vuln {"]} newline
     	{[Dealer "} First strhands  {"]} newline
     	{[Deal "} strHands {"]}  newline
    	"{Frq. NS  EO     %NS   %EO" newline
  	]
		Foreach F frquences[
  		a: parse/all F " "
  		b: copy ""
  		while [4 > ((length? b) + (length? first a))] [append b " "]
  		append b first a
  		while [(first tabulations) > (length? b)][append b " "]
  		append b second a
		if "PASSE" <> second a[if "%Tournoi" <> second a[
			while [(second tabulations) > (length? b)][append b " "]append b third a]
		]
  		while [(third tabulations) > (length? b)][append b " "]
		c: (to-integer((to-decimal fourth a) * 10)) / 10
  		append b c 
  		while [(fourth tabulations) > (length? b)][append b " "]
		c: (to-integer((to-decimal fifth a) * 10)) / 10
  		append b c 
     	append b newline
  		append Donne b
  	]
   append Donne "}"
; ajouter au fichier de format Deep Finesse au besoin
	if DF-Check/data[
		NordDF: DF-Format Nord
		EstDF: DF-Format Est
		SudDF: DF-Format Sud
		OuestDF: DF-Format Ouest
		append Donne-DF rejoin[
			newline
			newline
		]
		l: join	"Deal:  " NumDonne
		while [39 > length? L][append L " "]
		append Donne-DF join L NordDF
		L: copy "Contract:  3NT-South"
		while [22 > length? L][append L " "]
		append Donne-DF rejoin [newline L OuestDF "                   " EstDF newline]
		L: copy "OnLead:  West"
		while [39 > length? L][append L " "]
		append Donne-DF rejoin [L SudDF newline "Lead:  Any" newline "Result:" newline "Commentary:" newline Commentaire newline]
	]
  	append Donne rejoin[newline newline]
]
DF-Format: func[
	Main [string!]
	/local H
	][
	H: copy Main
	if #"." = first H [insert H "-"]
	if #"." = last H [append H "-"]
	replace/all H ".." " - "
	replace/all H "." " "
]
Name-file: does[				;change automatiquement le nom par dfaut
	N: index? find file-to-save "."
	either 2 > length? numro/text[
		poke file-to-save (n - 2) "0"
		][
		poke file-to-save (n - 2) first numro/text
	]
	poke file-to-save (n - 1) second numro/text
	fichier-dfaut/text: file-to-save
	show choix
]
date-dfaut: rejoin[now/day "/" now/month "/" Now/year]
date-id: rejoin[now/day now/month skip to-string now/year 2]
File-to-save: rejoin["SG" date-id ".pbn"]
;File-DF: ":C/Bridge/Deep Finesse 26-Nov-99/deal archives/SG10.txt"
File-DF: rejoin["SG" date-id ".txt"]
Montre: does[
	either DF-Check/data [
		show L1
		show fichier-DF
		][
		hide L1
		hide fichier-DF
	]
	show Choix
]
Change-Noms-Fichiers: does[
	a: replace copy Date/text "/20" ""
	replace a "/" ""
	file-to-save: rejoin["SG" a ".pbn"]
	fichier-dfaut/text: file-to-save
	file-DF: rejoin["SG" a ".txt"]
	fichier-DF/text: file-DF
	show Choix
]
Choix: layout[
	across
	h1 "Collecte de Rsultats" return
	h1 "Rondes Socit Gnrale" return
	h2 "Date " Date: field 70 Date-Dfaut [Change-Noms-Fichiers]
	h2 "Moment" Moment: rotary 80 "Aprs-midi" "Soir"  "Matin" return
	h2 "Fichier de Sauvegarde" fichier-dfaut: field 90 file-to-save return
	DF-check: check [montre] h2 "avec Deep Finesse" return
	L1: h2 "Fichier de Sauvegarde" fichier-DF: field 90 file-DF return
	button "Ok" [Connect] indent 60 button 100 "Parcourir" [Choix-fichier]
]
DF-Check/data: true
view Choix